/***************************************************************************

 Author        : Neil Zhao - MPD

 Date          : April 15th, 2015

 File          : ADXL355_SPI.c

 Hardware      : ADuC7026 and ADXL355

 Description   : Use hardware SPI of ADUC7026 to communicate with ADXL355

		
***************************************************************************/
#include <ADuC7026.h>	
#include "Common.h"

void SPI_ADXL355_WRITE(BYTE adress, BYTE data){

	unsigned char writeadress;
		
	GP1CLR = 0x800000;			 			 //CS3 = LOW
	delay(1);							//CS to SCLK set up time
	writeadress = adress<<1; 
	spiwrite(writeadress);		//write adress
	spiwrite(data);				//data to be written
	delay(1);							//CS to SCLK set up time
	GP1SET = 0x800000;		//CS3 = High	
	delay(1);							//Wait Time

}

void SPI_ADXL355_M_WRITE(BYTE adress, BYTE TXCONT){

	unsigned char	TXBYTE;
	unsigned char writeadress;
	GP1CLR = 0x800000;			 			 //CS3 = LOW
	delay(1);				//CS to SCLK set up time
	writeadress = adress<<1;
	spiwrite(writeadress);//write adress
	for(TXBYTE=0; TXBYTE<TXCONT; TXBYTE++)
	{
		spiwrite(r_data[TXBYTE]);	//data to be written
	}
	delay (1);						//CS to SCLK set up time
	GP1SET = 0x800000;		//CS3 = High	
	delay(1);						//Wait Time

}

unsigned char SPI_ADXL355_READ(BYTE adress){

	unsigned char result;
	unsigned char readadress;
	
	GP1CLR = 0x800000;			 			 //CS3 = LOW
	delay(1);				//CS to SCLK set up time
	readadress = adress<<1;
	readadress |= 0x01; 
	spiwrite(readadress);//read adress
	result = spiread();		//Read 8bit data (Send Dummy data 0x00)
	delay (1);				//CS to SCLK set up time
	GP1SET = 0x800000;		//CS3 = High	
	delay(1);				//Wait Time

	return result;
}

void SPI_ADXL355_M_READ(BYTE adress, BYTE RXCONT){

	unsigned char	RXBYTE;
	unsigned char readadress;
	GP1CLR = 0x800000;			 			 //CS3 = LOW
	delay(1);				//CS to SCLK set up time
	readadress = adress<<1;
	readadress |= 0x01; 
	spiwrite(readadress);//read adress
	for(RXBYTE=0; RXBYTE<RXCONT; RXBYTE++)
	{
		r_data[RXBYTE] = spiread();	//Read 8bit data (Send Dummy data 0x00)
	}
	delay (1);						//CS to SCLK set up time
	GP1SET = 0x800000;		//CS3 = High	
	delay(1);						//Wait Time

}
